DECLARE SUB RelaLine (x AS DOUBLE, y AS DOUBLE)
DECLARE SUB ProxyLine (x1 AS DOUBLE, y1 AS DOUBLE, x2 AS DOUBLE, y2 AS DOUBLE)
DECLARE SUB ProxyArc (x AS DOUBLE, y AS DOUBLE, radius AS DOUBLE, start AS DOUBLE, ending AS DOUBLE)
DECLARE FUNCTION arcsin# (x!)
DECLARE FUNCTION arccos# (x!)
SCREEN 12
CLS
DIM SHARED currentX AS DOUBLE, currentY AS DOUBLE, scale AS DOUBLE
DIM SHARED pi AS DOUBLE
pi = 3.141592653589793#
scale = 4
CALL ProxyLine(5, 99, 6, 100)
CALL RelaLine(14, 0)
CALL RelaLine(0, -12)
CALL RelaLine(-14, 0)
CALL RelaLine(-1, 1)
CALL RelaLine(0, 10)
CALL ProxyLine(6, 100, 6, 88)
CALL ProxyLine(21, 104, 21, 84)
CALL RelaLine(-1, 1)
CALL RelaLine(0, 18)
CALL RelaLine(1, 1)
CALL RelaLine(42, 0)
CALL RelaLine(1, -1)
CALL RelaLine(0, -18)
CALL RelaLine(-1, -1)
CALL RelaLine(0, 20)
CALL ProxyLine(21, 84, 63, 84)
CALL ProxyLine(64, 100, 79, 100)
CALL RelaLine(0, -12)
CALL RelaLine(-15, 0)
CALL ProxyLine(79, 98, 95, 98)
CALL RelaLine(0, -8)
CALL RelaLine(-16, 0)
CALL ProxyLine(80, 89, 80, 99)
CALL RelaLine(14, 0)
CALL RelaLine(0, -10)
CALL RelaLine(-14, 0)
CALL ProxyLine(94, 99, 95, 98)
CALL ProxyLine(94, 89, 95, 90)
CALL ProxyLine(37, 97, 47, 97)
CALL ProxyLine(37, 91, 47, 91)
CALL ProxyArc(37, 94, 3, 90, 270)
CALL ProxyArc(47, 94, 3, 270, 450)
CALL ProxyArc(40, 40, 10, arcsin(3 / 10), -arcsin(3 / 10))
CALL ProxyLine(40 + SQR(10 * 10 - 3 * 3), 43, 46.5, 43)
CALL RelaLine(0, -6)
CALL RelaLine(SQR(10 * 10 - 3 * 3) - 6.5, 0)
COLOR 4
CALL ProxyLine(0, 94, 100, 94)
CALL ProxyLine(25, 40, 55, 40)
CALL ProxyLine(40, 25, 40, 55)

DO WHILE INKEY$ = ""
LOOP

FUNCTION arccos# (x)

arccos# = 180 / pi * ATN(SQR(1 - x * x) / x)

END FUNCTION

FUNCTION arcsin# (x)

arcsin# = 180 / pi * ATN(x / SQR(1 - x * x))

END FUNCTION

SUB ProxyArc (x AS DOUBLE, y AS DOUBLE, radius AS DOUBLE, start AS DOUBLE, ending AS DOUBLE)

REM Use "ending" to represent "end" to avoid keyword conflict
DIM st AS DOUBLE, en AS DOUBLE
st = start / 180 * pi
en = ending / 180 * pi
st = st - 2 * pi * INT(st / (2 * pi))
en = en - 2 * pi * INT(en / (2 * pi))
IF st < en THEN
    CIRCLE (x * scale, 479 - y * scale), radius * scale, 15, st, en
ELSE
    CIRCLE (x * scale, 479 - y * scale), radius * scale, 15, st, 2 * pi
    CIRCLE (x * scale, 479 - y * scale), radius * scale, 15, 0, en
END IF

END SUB

SUB ProxyLine (x1 AS DOUBLE, y1 AS DOUBLE, x2 AS DOUBLE, y2 AS DOUBLE)

LINE (x1 * scale, 479 - (y1 * scale))-(x2 * scale, 479 - (y2 * scale))
currentX = x2: currentY = y2

END SUB

SUB RelaLine (x AS DOUBLE, y AS DOUBLE)

CALL ProxyLine(currentX, currentY, currentX + x, currentY + y)

END SUB

