DECLARE FUNCTION MemTest% (kMax AS SINGLE)
DECLARE FUNCTION MemTest.CalculateKMax! ()
DECLARE SUB BiosSetup.DrawItem (title AS STRING, active AS INTEGER, right AS INTEGER)
DECLARE SUB BiosSetup ()
DECLARE FUNCTION InputText$ (initText AS STRING)
DECLARE SUB SourceNotFound (lctn AS STRING)
DECLARE SUB ShowBottomText (showMem AS INTEGER)
DECLARE FUNCTION DetectIDE% (n AS INTEGER)
DECLARE FUNCTION SkipableSleep% (numSecs AS DOUBLE, keys() AS STRING)
DECLARE SUB NTStartBanner ()
DECLARE SUB InputText.sub1 (text AS STRING, dispBgn AS INTEGER, curPos AS INTEGER, lt AS INTEGER, rt AS INTEGER, askToDo AS INTEGER)
DECLARE FUNCTION min! (i!, j!)
DECLARE SUB SelectSource ()
DECLARE SUB PrepSetup ()
DECLARE SUB SubHelp ()
DECLARE SUB Banner ()
DECLARE SUB CopyFiles ()
DECLARE SUB CustomSleep (dblNumOfSeconds AS DOUBLE)
DECLARE FUNCTION endingQuest% ()
DECLARE FUNCTION SystemCheck% ()
DIM i AS INTEGER, j AS INTEGER
DIM kbd AS STRING

SCREEN 0
WIDTH 80, 25
LOCATE , , 0
PrepSetup
DO
  DO: kbd = INKEY$: LOOP UNTIL kbd <> ""
  SELECT CASE kbd
  CASE CHR$(0) + CHR$(59) 'F1 key
    SubHelp
    PrepSetup
  CASE CHR$(13) 'ENTER key
    EXIT DO
  CASE CHR$(0) + CHR$(61) 'F3 key
    IF endingQuest = 1 THEN
      GOTO lblEnd
    END IF
  END SELECT
LOOP

SelectSource

CopyFiles

DIM dTimer AS DOUBLE
COLOR 7, 0
CLS
PRINT "System is rebooting . . ."
dTimer = TIMER
DO WHILE TIMER - dTimer < 1
LOOP


dTimer = TIMER
DO WHILE TIMER - dTimer < 1
LOOP

DO WHILE NOT SystemCheck%
LOOP

CustomSleep 4

SystemSummary

SCREEN 0
COLOR 7, 0
WIDTH 80, 25
CLS
PRINT "OS Loader Version 4.01"
FOR i = 1 TO 10
   PRINT ".";
   CustomSleep .3
NEXT
WIDTH 80, 50
COLOR 7, 1
CLS
NTStartBanner
CustomSleep 10
NTStartPrint "."
CustomSleep .6
NTStartPrint "..."
CustomSleep .4
WIDTH 80, 25
WIDTH 80, 50
COLOR 7, 1
CLS
NTStartBanner
NTStartPrint "......"
CustomSleep .6
NTStartPrint "........."
CustomSleep .5
WIDTH 80, 25
WIDTH 80, 50
COLOR 7, 1
CLS
NTStartBanner
NTStartPrint "............"
CustomSleep 3
Locate , , 0

SCREEN 12
COLOR 3
LINE (0, 0)-(639, 479), , BF
CustomSleep 3

SCREEN 0
COLOR 7, 0
WIDTH 80, 25
CLS
PRINT "Thanks for installing Microsoft Windows 2000 Professional."
PRINT "We hope you enjoy this product and find more fun from it."
DO WHILE INKEY$ = ""
LOOP

lblEnd:
COLOR 7, 0
WIDTH 80, 25
CLS
SYSTEM
END

Sub SystemSummary
    Width 80, 25
    Color 7, 0
    Print "ͻ"
    Print " CPU Type          : PENTIUM II         Base Memory       :     640K          "
    Print " Co-Processor      : Installed          Extended Memory   :  326656K          "
    Print " CPU Clock         : 300MHz             Cache Memory      :     512K          "
    Print "Ķ"
    Print " Diskette Drive  A : 1.44M, 3.5 in.     Display Type      : EGA/VGA           "
    Print " Diskette Drive  B : 1.2 M, 5.25 in.    Serial Port(s)    : 3F8 2F8           "
    Print " Pri. Master  Disk : LBA,UMDA 33,40983M Parallel Port(s)  : 378               "
    Print " Pri. Slave   Disk : None               SDRAM at Row(s)   : 2 4 5             "
    Print " Sec. Master  Disk : None                                                     "
    Print " Sec. Slave   Disk : CDROM, UDMA 33                                           "
    Print "ͼ"
    Print
    Print
    Print "PCI device listing ..."
    Print "Bus No. Device No. Func No. Vender/Device Class Device Class               IRQ"
    Print ""
    Print "   0        7         1     8086   7111   0101  IDE Controller              14"
    Print "   0        7         2     8086   7112   0103  Serial Bus Controller       11"
    Print "   0       18         0     10EC   8139   0200  Network Controller          10"
    Print "   0       19         0     1013   6003   0401  Multimedia Device           11"
    Print "   1        0         0     1002   6003   0300  Display Controller          12"
    Print "                                                ADPI Controller              9"
    CustomSleep 2
    Print
    Print "Verifying DMI Pool Data ...";
    CustomSleep 1
    Print
End Sub

SUB Banner
    LOCATE 3, 4
    PRINT "Windows 2000 Professional Setup Program";
    LOCATE 4, 2
    PRINT ""
END SUB

SUB BiosSetup
    WIDTH 80, 25
    COLOR 15, 1
    CLS
    PRINT "                           ROM PCI/ISA BIOS(2A69KI3I)"
    PRINT "                               CMOS SETUP UTILITY"
    PRINT "                              AWARD SOFTWARE, INC."
    PRINT "ͻ"
    BiosSetup.DrawItem "STANDARD CMOS SETUP", -1, 0
    BiosSetup.DrawItem "IWILL SMART SETTING", 0, -1
    PRINT "                                                                             "
    BiosSetup.DrawItem "BIOS FEATURES SETUP", 0, 0
    BiosSetup.DrawItem "SUPERVISOR PASSWORD", 0, -1
    PRINT "                                                                             "
    BiosSetup.DrawItem "CHIPSET FEATURES SETUP", 0, 0
    BiosSetup.DrawItem "USER PASSWORD", 0, -1
    PRINT "                                                                             "
    BiosSetup.DrawItem "POWER MANAGEMENT SETUP", 0, 0
    BiosSetup.DrawItem "IDE HDD AUTO DETECTION", 0, -1
    PRINT "                                                                             "
    BiosSetup.DrawItem "PNP/PCI CONFIGURATION", 0, 0
    BiosSetup.DrawItem "SAVE & EXIT SETUP", 0, -1
    PRINT "                                                                             "
    BiosSetup.DrawItem "INTEGRATED PERIPHERALS", 0, 0
    BiosSetup.DrawItem "EXIT WITHOUT SAVING", 0, -1
    PRINT "                                                                             "
    BiosSetup.DrawItem "LOAD SETUP DEFAULTS", 0, 0
    PRINT SPACE$(38); ""
    PRINT "Ķ"
    PRINT " ESC : Quit                              ";
    PRINT CHR$(24) + CHR$(25) + CHR$(26) + CHR$(27) + " : Select Item                   "
    PRINT " F10 : Save & Exit Setup                 (Shift)F2 : Change Color             "
    PRINT "Ķ"
    PRINT "                                                                              "
    PRINT "                        Time, Date, Hard Disk Type...                         "
    PRINT "                                                                              ";
    LOCATE 25, 1
    PRINT "ͼ";
    DO WHILE INKEY$ = ""
    LOOP
END SUB

SUB BiosSetup.DrawItem (title AS STRING, active AS INTEGER, right AS INTEGER)
    DIM bgColor AS INTEGER
    IF NOT right THEN
        PRINT "";
    END IF
    PRINT "    ";
    bgColor = 1
    IF active THEN
        bgColor = 4
    END IF
    COLOR 14, bgColor
    PRINT title;
    COLOR 15, 1
    PRINT SPACE$(34 - LEN(title));
    IF NOT right THEN
        PRINT " ";
    ELSE
        PRINT ""
    END IF
END SUB

SUB CopyFiles
    DIM pflname AS STRING
    DIM ncopied AS LONG, totfiles AS LONG
    DIM interval AS LONG
    DIM kbd AS STRING
    DIM i AS INTEGER
    DIM j AS INTEGER
    DIM l AS LONG
    DIM tnextprn AS LONG
   
    COLOR 7, 1
    CLS
    Banner
    LOCATE 6, 4
    PRINT "Setup is copying files . . .";
    LOCATE 19, 9
    PRINT "Ŀ";
    LOCATE 20, 9
    PRINT "                                                              ";
    LOCATE 21, 9
    PRINT "";
    COLOR 0, 7
    LOCATE 25, 1
    PRINT " Setup is now copying                                                           ";
    COLOR 7, 1

    tnextprn = 0
    ncopied = 0
    OPEN "WINNT.TXT" FOR INPUT AS #2
    totfiles = 0
    DO WHILE NOT EOF(2)
      LINE INPUT #2, pflname
      totfiles = totfiles + 1
    LOOP
    CLOSE #2
    interval = 80000

    OPEN "WINNT.TXT" FOR INPUT AS #2
    DO
      'OPEN "~WINNT.TMP" FOR OUTPUT AS #1
      FOR l = 1 TO 100000
        IF tnextprn = 0 THEN
          kbd = INKEY$
          IF kbd <> "" THEN
            IF kbd = "=" THEN
              interval = interval / 2
            ELSE
              IF kbd = "-" THEN interval = interval * 2
            END IF
            IF interval > 8000000 THEN interval = 8000000
          END IF
          tnextprn = INT(RND * interval) + 1
          IF NOT EOF(2) THEN
            LINE INPUT #2, pflname
            ncopied = ncopied + 1
            'Default color is 7, 1
            LOCATE 19, 38
            PRINT "    ";
            LOCATE 19, 38
            PRINT STR$(CINT(ncopied / totfiles * 100)) + " %";
            COLOR 14
            LOCATE 20, 10
            FOR i = 1 TO CINT(ncopied / totfiles * 62)
              PRINT "";
            NEXT
            COLOR 7 'Set to default color
          ELSE
            'CLOSE #1
            'KILL "~WINNT.TMP"
            EXIT DO
          END IF
          COLOR 0, 7
          LOCATE 25, 62
          PRINT "                   ";
          LOCATE 25, 62
          PRINT " " + pflname;
          COLOR 7, 1
        END IF
        'PRINT #1, "Winnt.exe is copying files. But memory overflows . . ."
        tnextprn = tnextprn - 1
      NEXT
      'CLOSE #1
      'KILL "~WINNT.TMP"
    LOOP
END SUB

SUB CustomSleep (dblNumOfSeconds AS DOUBLE)
   DIM dblStartTimer
   dblStartTimer = TIMER
   DO WHILE TIMER - dblStartTimer < dblNumOfSeconds
   LOOP
END SUB

FUNCTION DetectIDE% (n AS INTEGER)
    DIM f4kbd$
    DIM hintStr0 AS STRING
    DIM hintStr1 AS STRING
    DIM hintStr2 AS STRING
    DIM hintLen AS INTEGER
    DIM keys(0 TO 1) AS STRING
    DIM rtnVal AS INTEGER
    rtnVal = -1
    f4kbd$ = CHR$(0) + CHR$(62)
    keys(0) = f4kbd$
    keys(1) = CHR$(0) + CHR$(83)
    hintStr0 = "[Press "
    hintStr1 = "F4"
    hintStr2 = " to skip]"
    PRINT hintStr0;
    COLOR 15
    PRINT hintStr1;
    COLOR 7
    PRINT hintStr2;
    hintLen = LEN(hintStr0 + hintStr1 + hintStr2)
    LOCATE , POS(0) - hintLen
    DIM deviceString(0 TO 3) AS STRING
    deviceString(0) = "MAXTOR 34098H4"
    deviceString(1) = "None"
    deviceString(2) = "None"
    deviceString(3) = "ATAPI CDROM DRIVE 40X MAXIMUM"
    SELECT CASE SkipableSleep%(4, keys())
    CASE -1
        PRINT SPACE$(hintLen);
        LOCATE , POS(0) - hintLen
        PRINT deviceString(n)
    CASE 0
        PRINT SPACE$(hintLen);
        LOCATE , POS(0) - hintLen
        PRINT "Skip"
    CASE 1
        rtnVal = 0
    END SELECT
    DetectIDE% = rtnVal
END FUNCTION

FUNCTION endingQuest%

DIM kbd AS STRING
COLOR 4, 7
LOCATE 13, 25
PRINT "ͻ"
LOCATE 14, 25
PRINT "    Do you really want to    "
LOCATE 15, 25
PRINT "     exit Setup [Y/N]?       "
LOCATE 16, 25
PRINT "                             "
LOCATE 17, 25
PRINT "ͼ"
DO
  kbd = ""
  WHILE kbd = "": kbd = INKEY$: WEND
  IF kbd = "Y" OR kbd = "y" THEN
    endingQuest = 1
    EXIT DO
  ELSE
    IF kbd = "N" OR kbd = "n" THEN
      endingQuest = 0
      COLOR 7, 1
      LOCATE 13, 1
      PRINT SPACE$(80);
      PRINT SPACE$(80);
      PRINT SPACE$(80);
      PRINT SPACE$(80);
      PRINT SPACE$(80);
      EXIT DO
    END IF
  END IF
LOOP

END FUNCTION

FUNCTION InputText$ (initText AS STRING)
    DIM lt AS INTEGER
    DIM rt AS INTEGER
    DIM kbd AS STRING
    lt = POS(0) - 1
    rt = 80 - lt  ' the position on the right of the right boundary
    COLOR 0, 7
    PRINT SPACE$(rt - lt);
    LOCATE , lt + 1
    PRINT initText;
    LOCATE , lt + 1 + LEN(initText), 1, 6, 7
    DIM curPos AS INTEGER
    DIM dispBgn AS INTEGER
    DIM newText AS STRING
    curPos = LEN(initText)
    dispBgn = 0
    newText = initText
    DO
        DO
            kbd = INKEY$
        LOOP UNTIL kbd <> ""
        SELECT CASE kbd
        CASE CHR$(0) + CHR$(75) ' Left
            IF curPos > 0 THEN
                curPos = curPos - 1
                InputText.sub1 newText, dispBgn, curPos, lt, rt, 0
            END IF
        CASE CHR$(0) + CHR$(77) ' Right
            IF curPos < LEN(newText) THEN
                curPos = curPos + 1
                InputText.sub1 newText, dispBgn, curPos, lt, rt, 0
            END IF
        CASE CHR$(0) + CHR$(79)  ' End
            curPos = LEN(newText)
            InputText.sub1 newText, dispBgn, curPos, lt, rt, 0
        CASE CHR$(0) + CHR$(71)  ' Home
            curPos = 0
            InputText.sub1 newText, dispBgn, curPos, lt, rt, 0
        CASE CHR$(8)  ' Backspace
            IF curPos > 0 THEN
                newText = LEFT$(newText, curPos - 1) + MID$(newText, curPos + 1)
                curPos = curPos - 1
                InputText.sub1 newText, dispBgn, curPos, lt, rt, -1
            END IF
        CASE CHR$(0) + CHR$(83)  ' Delete
            IF curPos < LEN(newText) THEN
                newText = LEFT$(newText, curPos) + MID$(newText, curPos + 2)
                InputText.sub1 newText, dispBgn, curPos, lt, rt, -1
            END IF
        CASE " " TO "~"
            newText = LEFT$(newText, curPos) + kbd + MID$(newText, curPos + 1)
            curPos = curPos + 1
            InputText.sub1 newText, dispBgn, curPos, lt, rt, -1
        CASE CHR$(13)
            GOTO AfterLoop
        END SELECT
    LOOP
AfterLoop:
    LOCATE , , 0
    InputText$ = newText
END FUNCTION

SUB InputText.sub1 (text AS STRING, dispBgn AS INTEGER, curPos AS INTEGER, lt AS INTEGER, rt AS INTEGER, askToDo AS INTEGER)
    DIM dispStr AS STRING
    DIM toDo AS INTEGER
    toDo = askToDo
    IF dispBgn > curPos THEN
        dispBgn = curPos
        toDo = -1
    ELSEIF dispBgn + rt - lt - 1 < curPos THEN
        dispBgn = curPos - rt + lt + 1
        toDo = -1
    END IF
    IF toDo THEN
        dispStr = MID$(text, dispBgn + 1, min(rt - lt, LEN(text) - dispBgn))
        LOCATE , lt + 1
        PRINT dispStr + SPACE$(rt - lt - LEN(dispStr));
    END IF
    LOCATE , lt + curPos - dispBgn + 1
END SUB

FUNCTION MemTest% (kMax AS SINGLE)
    DIM testSkipped AS INTEGER
    DIM intCsrPos AS INTEGER
    DIM i AS INTEGER, j AS INTEGER
    DIM k AS INTEGER
    DIM kbd AS STRING
    CONST iMax! = 1000
    testSkipped = 0
    PRINT "Memory Test :";
    intCsrPos = POS(0)
    PRINT "        K OK";
    FOR j = 1 TO 3
        FOR i = 1 TO iMax!
            FOR k = 1 TO kMax
                LOCATE , intCsrPos
                PRINT USING "########"; (i / iMax! + k / iMax! / kMax) * 327680!;
            NEXT
            kbd = INKEY$
            IF kbd = CHR$(27) OR kbd = CHR$(0) + CHR$(83) THEN
                testSkipped = -1
                GOTO AfterMemTest
            END IF
        NEXT
    NEXT
AfterMemTest:
    LOCATE , intCsrPos
    PRINT "  327680K OK";
    IF kbd = CHR$(0) + CHR$(83) THEN
        MemTest% = 1
    ELSE
        MemTest% = 0
    END IF
END FUNCTION

FUNCTION MemTest.CalculateKMax!
    DIM strtTime AS DOUBLE
    DIM kMax AS SINGLE
    DIM kMaxOld AS SINGLE
    strtTime = TIMER
    kMax = 0
    DO WHILE TIMER - strtTime < 1
        kMaxOld = kMax
        DO WHILE kMax - kMaxOld < 1
            kMax = kMax + .001
        LOOP
    LOOP
    kMax = kMax * 1.5
    MemTest.CalculateKMax! = kMax
END FUNCTION

FUNCTION min! (i!, j!)
    IF i! <= j! THEN
        min! = i!
    ELSE
        min! = j!
    END IF
END FUNCTION

SUB NTStartBanner
    PRINT "Microsoft (R) Windows NT (TM) Version 4.0 (Build 1381: Service Pack 4)."
    PRINT "1 System Processor [320 MB Memory]"
    Locate 1, 1, 1, 6, 7
END SUB

Sub NTStartPrint (content As String)
    Locate 3, 1
    Print content
    Locate 1, 1
End Sub

SUB PrepSetup
    COLOR 7, 1
    CLS
    Banner
    LOCATE 6, 6
    PRINT "For more information before continue, press F1"
    LOCATE 8, 6
    PRINT "To continue installation, press ENTER"
    LOCATE 10, 6
    PRINT "To exit setup, press F3"
END SUB

SUB SelectSource
    DIM userInput AS STRING
    userInput = "E:\"
    DO
        COLOR 7, 1
        CLS
        Banner
        PRINT
        PRINT
        PRINT
        PRINT "     Please specify the location of the Windows 2000 Professional"
        PRINT "     setup files."
        PRINT
        PRINT
        PRINT
        PRINT "     ";
        userInput = InputText$(userInput)
        IF UCASE$(userInput) <> "E:\I386" THEN
            SourceNotFound userInput
        ELSE
            EXIT DO
        END IF
    LOOP
END SUB

SUB ShowBottomText (showMem AS INTEGER)
    DIM orgLin AS INTEGER
    DIM orgPos AS INTEGER
    orgLin = CSRLIN
    orgPos = POS(0)
    LOCATE 29, 1
    PRINT SPACE$(80);
    LOCATE , 1
    PRINT "Press ";
    COLOR 15
    PRINT "DEL";
    COLOR 7
    PRINT " to enter SETUP";  ' do not return at end of line
    IF showMem THEN
        PRINT ", ";
        COLOR 15
        PRINT "ESC";
        COLOR 7
        PRINT " to skip memory test";
    END IF
    LOCATE orgLin, orgPos
END SUB

FUNCTION SkipableSleep% (numSecs AS DOUBLE, keys() AS STRING)
    DIM dblStartTimer
    DIM rtnVal AS INTEGER
    DIM kbd AS STRING
    DIM i AS INTEGER
    rtnVal = -1
    dblStartTimer = TIMER
    DO WHILE TIMER - dblStartTimer < numSecs
        kbd = INKEY$
        FOR i = LBOUND(keys) TO UBOUND(keys)
            IF kbd = keys(i) THEN
                rtnVal = i
                EXIT DO
            END IF
        NEXT
    LOOP
    SkipableSleep% = rtnVal
END FUNCTION

SUB SourceNotFound (lctn AS STRING)
    COLOR 7, 1
    CLS
    Banner
    PRINT
    PRINT "     Files required by Windows 2000 Setup are not found in the following"
    PRINT "     directory: "
    PRINT
    PRINT "     " + lctn
    PRINT
    PRINT "     Please verify the location you typed is correct."
    PRINT
    PRINT
    PRINT
    PRINT
    PRINT
    PRINT
    PRINT
    PRINT
    PRINT
    PRINT
    PRINT "     Press ENTER to choose another location"
    DO WHILE INKEY$ <> CHR$(13)
    LOOP
END SUB

SUB SubHelp
    COLOR 7, 1
    CLS
    Banner
    PRINT
    PRINT "   Welcome to the Windows 2000 Professional Setup Program. This program"
    PRINT "   will guide you through the Windows 2000 setup process automatically."
    PRINT "   During the setup process, the target partition will be prepared and the"
    PRINT "   files required will be copied there."
    PRINT
    PRINT "   Windows 2000 Professional is a stable, reliable, compatible and durable"
    PRINT "   operating system. Microsoft ensures you a clean, secure and portable"
    PRINT "   operating system. We keep developing this product and more and more new"
    PRINT "   technologies will be applied to this product."
    PRINT
    PRINT "   For more information on Windows 2000 and our other products,"
    PRINT "   please visit:"
    PRINT
    PRINT "   http://www.microsoft.com/"
    PRINT
    PRINT "   Press ESC to return to Setup Menu"
    DO WHILE INKEY$ <> CHR$(27)
    LOOP
END SUB

FUNCTION SystemCheck%
    DIM i AS INTEGER
    DIM kMax!
    SCREEN 12
    CLS
    kMax! = MemTest.CalculateKMax!
    CustomSleep 5
    SOUND 800, 4
    ' Draw auxiliary elements first
    COLOR 9
    PRINT "ɻ"
    PRINT "ȼ"
    COLOR 7
    ShowBottomText -1
    LOCATE 30, 1
    PRINT "08/10/1999-i440BX-W977EF-2A69KI3IC-07";
    COLOR 7
    LOCATE 1
    LOCATE , 4: PRINT "Award Modular BIOS v4.51PGM, An Energy Star Ally"
    LOCATE , 4: PRINT "Copyright (C) 1984-99, Award Software, Inc."
    PRINT
    PRINT "BD100Plus/31310A (Aug.10.1999)"
    PRINT
    PRINT "PENTIUM II CPU at 300MHz"
    IF MemTest%(kMax!) THEN
        PRINT
        PRINT
        PRINT "Award Plug and Pluy BIOS Extension v1.0A"
        PRINT "Copyright (C) 1999, Award Software, Inc."
        ShowBottomText 0
        CustomSleep 4
        BiosSetup
        SystemCheck% = 0
        EXIT FUNCTION
    END IF
    ShowBottomText 0
    PRINT
    PRINT
    PRINT "Award Plug and Pluy BIOS Extension v1.0A"
    PRINT "Copyright (C) 1999, Award Software, Inc."
    DIM idePorts(0 TO 3) AS STRING
    idePorts(0) = "Primary Master  "
    idePorts(1) = "Primary Slave   "
    idePorts(2) = "Secondary Master"
    idePorts(3) = "Secondary Slave "
    FOR i = 0 TO 3
        PRINT "  Detecting " + idePorts(i) + "... ";
        IF NOT DetectIDE%(i) THEN
            BiosSetup
            SystemCheck% = 0
            EXIT FUNCTION
        END IF
    NEXT
    SystemCheck% = -1
END FUNCTION

