DECLARE SUB InitCatTab (strCatTab() AS STRING)
DECLARE FUNCTION IsY% (strAns AS STRING)
DECLARE FUNCTION GetCatCharCount% (intCat() AS INTEGER, strCatTab() AS STRING)
DECLARE FUNCTION GetCatChar$ (intCats() AS INTEGER, strCatTab() AS STRING, intIdx AS INTEGER)

DEFSTR A-Z

CONST True = -1
CONST False = 0

CONST CategoryCount = 4
CONST CharCount = 127 - 32
CONST LetterCount = 26
CONST DigitCount = 10
CONST SymbolCount = CharCount - LetterCount * 2 - DigitCount

DIM i AS INTEGER, n AS INTEGER, j AS INTEGER
DIM intCats(0 TO CategoryCount - 1) AS INTEGER
DIM strCatTab(0 TO CharCount - 1) AS STRING
DIM strAns AS STRING

' categories:
' 0 - little letters
' 1 - capital letters
' 2 - digits
' 3 - symbolic characters

i = 0
PRINT "Please select the categories:"
INPUT "Little letters? ", strAns
intCats(i) = IsY%(strAns): i = i + 1
INPUT "Capital letters? ", strAns
intCats(i) = IsY%(strAns): i = i + 1
INPUT "Digits? ", strAns
intCats(i) = IsY%(strAns): i = i + 1
INPUT "Sympolic characters? ", strAns
intCats(i) = IsY%(strAns): i = i + 1

CALL InitCatTab(strCatTab())

INPUT "How many characters do you want? ", n
IF n > 1000 OR n < 5 THEN
   PRINT "The number you specified is not in the required range."
ELSE
   PRINT "These codes below are the password generated for you:"
   RANDOMIZE TIMER
   PRINT "[";
   FOR i = 1 TO n
      DO WHILE INKEY$ = ""
         j = INT(RND * GetCatCharCount%(intCats(), strCatTab()))
         PRINT GetCatChar$(intCats(), strCatTab(), j);
         IF POS(0) = 1 THEN
            LOCATE CSRLIN - 1, 80
         ELSE
            LOCATE , POS(0) - 1
         END IF
      LOOP
      IF POS(0) = 80 THEN
         LOCATE CSRLIN + 1, 1
      ELSE
         LOCATE , POS(0) + 1
      END IF
   NEXT
   PRINT "]";
END IF
PRINT
END

FUNCTION GetCatChar$ (intCats() AS INTEGER, strCatTab() AS STRING, intIdx AS INTEGER)

DIM i AS INTEGER
DIM j AS INTEGER
DIM intCounts(0 TO CategoryCount - 1) AS INTEGER
DIM intBase AS INTEGER

i = 0
intCounts(i) = LetterCount: i = i + 1
intCounts(i) = LetterCount: i = i + 1
intCounts(i) = DigitCount: i = i + 1
intCounts(i) = SymbolCount: i = i + 1

j = intIdx
intBase = 0
FOR i = 0 TO CategoryCount - 1
    IF intCats(i) THEN
        IF j < intCounts(i) THEN
            EXIT FOR
        END IF
        j = j - intCounts(i)
    END IF
    intBase = intBase + intCounts(i)
NEXT
IF i >= CategoryCount THEN ' no category is selected by user
    GetCatChar$ = " "
    EXIT FUNCTION
END IF
GetCatChar$ = strCatTab(intBase + j)

END FUNCTION

FUNCTION GetCatCharCount% (intCat() AS INTEGER, strCatTab() AS STRING)

DIM intCnt AS INTEGER

intCnt = 0
IF intCat(0) THEN
    intCnt = intCnt + LetterCount
END IF
IF intCat(1) THEN
    intCnt = intCnt + LetterCount
END IF
IF intCat(2) THEN
    intCnt = intCnt + DigitCount
END IF
IF intCat(3) THEN
    intCnt = intCnt + SymbolCount
END IF
GetCatCharCount% = intCnt

END FUNCTION

DEFSNG A-Z
SUB InitCatTab (strCatTab() AS STRING)

DIM i AS INTEGER
DIM j AS INTEGER

j = 0
FOR i = ASC("a") TO ASC("z")
    strCatTab(j) = CHR$(i)
    j = j + 1
NEXT
FOR i = ASC("A") TO ASC("Z")
    strCatTab(j) = CHR$(i)
    j = j + 1
NEXT
FOR i = ASC("0") TO ASC("9")
    strCatTab(j) = CHR$(i)
    j = j + 1
NEXT
FOR i = ASC(" ") TO ASC("~")
    IF NOT (ASC("a") <= i AND i <= ASC("z") OR ASC("A") <= i AND i <= ASC("Z") OR ASC("0") <= i AND i <= ASC("9")) THEN
        strCatTab(j) = CHR$(i)
        j = j + 1
    END IF
NEXT

END SUB

FUNCTION IsY% (strAns AS STRING)

IF LCASE$(strAns) = "y" OR LCASE$(strAns) = "yes" THEN
    IsY% = True
ELSE
    IsY% = False
END IF

END FUNCTION

